From d505f7b6be1f007151764f84c075cde45d61447a Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 708/1001] Adapt views and templates to the new widget class


---

diff --git a/hubs/tests/test_fedora_hubs_flask_api.py b/hubs/tests/test_fedora_hubs_flask_api.py
index 1ca2a8d..9f6383a 100644
--- a/hubs/tests/test_fedora_hubs_flask_api.py
+++ b/hubs/tests/test_fedora_hubs_flask_api.py
@@ -223,7 +223,7 @@ class HubsAPITest(hubs.tests.APPTest):
         result = self.app.get('/ralph/add?position=right',
                               follow_redirects=True)
         self.assertEqual(result.status_code, 200)
-        expected_str = 'Adding widget to hub: ralph'
+        expected_str = 'Adding a widget to hub: ralph'
         self.assertIn(expected_str, result.get_data(as_text=True))
         expected_str = "url: 'add/' + $('#widget').val() + '?position=right',"
         self.assertIn(expected_str, result.get_data(as_text=True))
@@ -337,7 +337,7 @@ class HubsAPITest(hubs.tests.APPTest):
         with tests.auth_set(app, user):
             url = '/ralph/add/about?position=right'
             result = self.app.get(url)
-            self.assertIn('Adding widget "about"to hub: ralph',
+            self.assertIn('Adding widget "about" to hub: ralph',
                           result.get_data(as_text=True))
 
     def test_hub_add_widget_invalid_side(self):
diff --git a/hubs/views/hub.py b/hubs/views/hub.py
index f64f261..27e9235 100644
--- a/hubs/views/hub.py
+++ b/hubs/views/hub.py
@@ -158,19 +158,14 @@ def hub_add_widget(name, widget_name):
     if side not in ['right', 'left']:
         flask.abort(400, 'Invalid position provided')
 
-    widget = None
-    w_name = None
-    for widgt in hubs.widgets.registry:
-        if hubs.widgets.registry[widgt].position in ['both', side] \
-                and widgt == widget_name:
-            w_name = widgt
-            widget = hubs.widgets.registry[widgt]
+    widget = hubs.widgets.registry[widget_name]
+    if widget.position not in ['both', side]:
+        flask.abort(400, "This widget can't be placed here")
 
     return flask.render_template(
         'add_widget.html',
         hub=hub,
         widget=widget,
-        widget_name=w_name,
         side=side,
         url_to=flask.url_for('hub_add_widgets', name=name),
     )
@@ -209,7 +204,7 @@ def hub_add_widget_post(name):
         plugin=widget_name, index=-1, left=position == 'left')
     error = False
     config = {}
-    for arg in widget.module.data.widget_arguments:
+    for arg in widget.module.get_arguments():
         val = flask.request.form.get(arg.name)
         if not val:
             flask.flash(
diff --git a/hubs/views/utils.py b/hubs/views/utils.py
index df05992..94113e3 100644
--- a/hubs/views/utils.py
+++ b/hubs/views/utils.py
@@ -3,7 +3,6 @@ from __future__ import unicode_literals
 import flask
 import functools
 import hubs.models
-import hubs.widgets
 
 from six.moves.urllib import parse as urlparse
 from sqlalchemy.orm.exc import NoResultFound
diff --git a/hubs/views/widget.py b/hubs/views/widget.py
index 613e47d..cbc002c 100644
--- a/hubs/views/widget.py
+++ b/hubs/views/widget.py
@@ -4,17 +4,10 @@ import datetime
 import flask
 
 from hubs.app import app
+from pkg_resources import resource_isdir
 from .utils import get_widget_instance
 
 
-@app.route('/<hub>/<int:idx>/')
-@app.route('/<hub>/<int:idx>')
-def widget_render(hub, idx):
-    widget = get_widget_instance(hub, idx)
-    return widget.render()  # , edit=False)
-    # was blocking all widgets from working, sorry!
-
-
 @app.route('/<hub>/<int:idx>/json')
 @app.route('/<hub>/<int:idx>/json/')
 def widget_json(hub, idx):
@@ -47,7 +40,7 @@ def widget_edit_post(hub, idx):
     widget = get_widget_instance(hub, idx)
     error = False
     config = {}
-    for arg in widget.module.data.widget_arguments:
+    for arg in widget.module.get_arguments():
         val = flask.request.form.get(arg.name)
         if not val:
             flask.flash(
@@ -96,14 +89,17 @@ def widget_edit_delete(hub, idx):
 @app.route('/source/<name>')
 def widget_source(name):
     from hubs.widgets import registry
-    base = '/hubs/'
-    fname = ''
 
     try:
-        fname = base + registry[name].__file__.split(base)[-1]
+        widget_path = registry[name].__module__
     except KeyError:
         flask.abort(404)
-
-    fname = fname.replace('.pyc', '.py')
-    return flask.redirect(app.config.get('SOURCE_URL') + fname)
+    widget_url = widget_path.replace(".", "/")
+    parent, _ignore, module = widget_path.rpartition(".")
+    if resource_isdir(parent, module):
+        widget_url += "/__init__.py"
+    else:
+        widget_url += ".py"
+    url = "/".join([app.config.get('SOURCE_URL'), widget_url])
+    return flask.redirect(url)
 
